/*
 * Filter
 * Copyright (C) 2011 by Apaq
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package dk.apaq.filter.jpa.interpreters;

import dk.apaq.filter.core.CompareFilter;
import dk.apaq.filter.jpa.WhereClause;

/**
 *
 * @author michael
 */
public class CompareFilterInterpreter extends AbstractInterpreter<CompareFilter> {

    public boolean interpret(WhereClause clause, CompareFilter filter) {
        String paramName = getParamName();
        String operator = null;

        switch (filter.getCompareType()) {
            case Equals:
                operator = "=";
                break;
            case GreaterOrEqual:
                operator = ">=";
                break;
            case GreaterThan:
                operator = ">";
                break;
            case LessOrEqual:
                operator = "<=";
                break;
            case LessThan:
                operator = "<";
                break;
        }

        String jpql = "e." + filter.getPropertyId() + operator + ":" + paramName;
        clause.appendStatement(jpql);
        clause.appendParameter(paramName, filter.getValue());
        return true;
    }
}
